/**
 *
 */
package com.ferri.core.vo;

import java.io.Serializable;

import org.apache.commons.lang.builder.ToStringBuilder;
import org.apache.commons.lang.builder.ToStringStyle;

/**
 * @author dferri
 */
public abstract class AbstractBase implements Serializable {
	public AbstractBase() {
		initialize();
	}

	/**
	 * Initializes this instance.
	 */
	protected abstract void initialize();

	/**
	 * Returns the string representation for this object.
	 *
	 * @return String the string representation for this object.
	 */
	@Override
	public String toString() {
		return ToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
	}
}
