package com.ferri.persistence.bean.base;


import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsContadorVO;

/**
 * Base del VO cont els atributs de la entitat Contador 
 * @author dferri
 *
 */
public abstract class BaseContadorVO extends BaseVO implements ConstantsContadorVO{
	
	private static final long serialVersionUID = -1271503737916549291L;
	private int hashCode = -2147483648;

	//PK
	private Integer any = null;
	private String tipus = null;
	private Integer numero = null;

	/**
	 * Creador instancia
	 */
	public BaseContadorVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param any
	 * @param tipus
	 * @param numero
	 */
	public BaseContadorVO(Integer any, String tipus, Integer numero){
		this.any = any;
		this.tipus = tipus;
		this.numero = numero;
		initialize();
	}

	/**
	 * @return the any
	 */
	public Integer getAny() {
		return any;
	}

	/**
	 * @param any the any to set
	 */
	public void setAny(Integer any) {
		this.any = any;
	}

	/**
	 * @return the tipus
	 */
	public String getTipus() {
		return tipus;
	}

	/**
	 * @param tipus the tipus to set
	 */
	public void setTipus(String tipus) {
		this.tipus = tipus;
	}

	/**
	 * @return the numero
	 */
	public Integer getNumero() {
		return numero;
	}

	/**
	 * @param numero the numero to set
	 */
	public void setNumero(Integer numero) {
		this.numero = numero;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((any == null) ? 0 : any.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((numero == null) ? 0 : numero.hashCode());
		result = prime * result + ((tipus == null) ? 0 : tipus.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseContadorVO other = (BaseContadorVO) obj;
		if (any == null) {
			if (other.any != null)
				return false;
		} else if (!any.equals(other.any))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (numero == null) {
			if (other.numero != null)
				return false;
		} else if (!numero.equals(other.numero))
			return false;
		if (tipus == null) {
			if (other.tipus != null)
				return false;
		} else if (!tipus.equals(other.tipus))
			return false;
		return true;
	}
	
}
	
