package com.ferri.persistence.bean.base;


import java.util.Date;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsContracteVO;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.FacturaVO;
import com.ferri.persistence.bean.impl.TipusPeriodeVO;

/**
 * Base del VO cont els atributs de la entitat Contracte 
 * @author dferri
 *
 */
public abstract class BaseContracteVO extends BaseVO implements ConstantsContracteVO{
	
	private static final long serialVersionUID = -969111716765358692L;
	private int hashCode = -2147483648;

	//PK
	private String numContracte = null;
	
	//Fields
	private Date 			data 			= null;	
	private Integer 		mesIni 			= null;
	private Double 			baseImponible 	= null;
	private EstatVO 		estat  			= null;
	private ClientVO 		client  		= null;
	private TipusPeriodeVO	tipusPeriode  	= null;
	private FacturaVO 		factura			= null;
	
	/**
	 * Creador instancia
	 */
	public BaseContracteVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param numContracte
	 */
	public BaseContracteVO(String numContracte){
		this.numContracte = numContracte;
		initialize();
	}

	/**
	 * @return the numContracte
	 */
	public String getNumContracte() {
		return numContracte;
	}

	/**
	 * @param numContracte the numContracte to set
	 */
	public void setNumContracte(String numContracte) {
		this.numContracte = numContracte;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the mesIni
	 */
	public Integer getMesIni() {
		return mesIni;
	}

	/**
	 * @param mesIni the mesIni to set
	 */
	public void setMesIni(Integer mesIni) {
		this.mesIni = mesIni;
	}

	/**
	 * @return the estat
	 */
	public EstatVO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatVO estat) {
		this.estat = estat;
	}

	/**
	 * @return the client
	 */
	public ClientVO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientVO client) {
		this.client = client;
	}

	/**
	 * @return the tipusPeriode
	 */
	public TipusPeriodeVO getTipusPeriode() {
		return tipusPeriode;
	}

	/**
	 * @param tipusPeriode the tipusPeriode to set
	 */
	public void setTipusPeriode(TipusPeriodeVO tipusPeriode) {
		this.tipusPeriode = tipusPeriode;
	}

	/**
	 * @return the factura
	 */
	public FacturaVO getFactura() {
		return factura;
	}

	/**
	 * @param factura the factura to set
	 */
	public void setFactura(FacturaVO factura) {
		this.factura = factura;
	}
	
	/**
	 * @return the baseImponible
	 */
	public Double getBaseImponible() {
		return baseImponible;
	}

	/**
	 * @param baseImponible the baseImponible to set
	 */
	public void setBaseImponible(Double baseImponible) {
		this.baseImponible = baseImponible;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((baseImponible == null) ? 0 : baseImponible.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + ((factura == null) ? 0 : factura.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((mesIni == null) ? 0 : mesIni.hashCode());
		result = prime * result
				+ ((numContracte == null) ? 0 : numContracte.hashCode());
		result = prime * result
				+ ((tipusPeriode == null) ? 0 : tipusPeriode.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseContracteVO other = (BaseContracteVO) obj;
		if (baseImponible == null) {
			if (other.baseImponible != null)
				return false;
		} else if (!baseImponible.equals(other.baseImponible))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (factura == null) {
			if (other.factura != null)
				return false;
		} else if (!factura.equals(other.factura))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (mesIni == null) {
			if (other.mesIni != null)
				return false;
		} else if (!mesIni.equals(other.mesIni))
			return false;
		if (numContracte == null) {
			if (other.numContracte != null)
				return false;
		} else if (!numContracte.equals(other.numContracte))
			return false;
		if (tipusPeriode == null) {
			if (other.tipusPeriode != null)
				return false;
		} else if (!tipusPeriode.equals(other.tipusPeriode))
			return false;
		return true;
	}

}
	
