package com.ferri.persistence.bean.base;


import java.util.Date;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsFacturaVO;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;

/**
 * Base del VO cont els atributs de la entitat Factura 
 * @author dferri
 *
 */
public abstract class BaseFacturaVO extends BaseVO implements ConstantsFacturaVO{
	
	private static final long serialVersionUID = 1708833437574231496L;
	private int hashCode = -2147483648;

	//PK
	private String numFactura = null;
	
	//Fields
	private Date data = null;
	private Double baseImponible = null;
	private String concepte = null;
	private Date dataCobrament = null;
	private EstatVO estat = null;
	private ClientVO client = null; 
	
	
	/**
	 * Creador instancia
	 */
	public BaseFacturaVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param numFactura
	 */
	public BaseFacturaVO(String numFactura){
		this.numFactura = numFactura;
		initialize();
	}

	/**
	 * @return the numFactura
	 */
	public String getNumFactura() {
		return numFactura;
	}

	/**
	 * @param numFactura the numFactura to set
	 */
	public void setNumFactura(String numFactura) {
		this.numFactura = numFactura;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the baseImponible
	 */
	public Double getBaseImponible() {
		return baseImponible;
	}

	/**
	 * @param baseImponible the baseImponible to set
	 */
	public void setBaseImponible(Double baseImponible) {
		this.baseImponible = baseImponible;
	}

	/**
	 * @return the concepte
	 */
	public String getConcepte() {
		return concepte;
	}

	/**
	 * @param concepte the concepte to set
	 */
	public void setConcepte(String concepte) {
		this.concepte = concepte;
	}

	/**
	 * @return the dataCobrament
	 */
	public Date getDataCobrament() {
		return dataCobrament;
	}

	/**
	 * @param dataCobrament the dataCobrament to set
	 */
	public void setDataCobrament(Date dataCobrament) {
		this.dataCobrament = dataCobrament;
	}

	/**
	 * @return the estat
	 */
	public EstatVO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatVO estat) {
		this.estat = estat;
	}

	/**
	 * @return the client
	 */
	public ClientVO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientVO client) {
		this.client = client;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((baseImponible == null) ? 0 : baseImponible.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result
				+ ((concepte == null) ? 0 : concepte.hashCode());
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		result = prime * result
				+ ((dataCobrament == null) ? 0 : dataCobrament.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + hashCode;
		result = prime * result
				+ ((numFactura == null) ? 0 : numFactura.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseFacturaVO other = (BaseFacturaVO) obj;
		if (baseImponible == null) {
			if (other.baseImponible != null)
				return false;
		} else if (!baseImponible.equals(other.baseImponible))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (concepte == null) {
			if (other.concepte != null)
				return false;
		} else if (!concepte.equals(other.concepte))
			return false;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		if (dataCobrament == null) {
			if (other.dataCobrament != null)
				return false;
		} else if (!dataCobrament.equals(other.dataCobrament))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (numFactura == null) {
			if (other.numFactura != null)
				return false;
		} else if (!numFactura.equals(other.numFactura))
			return false;
		return true;
	}

}
	
