package com.ferri.persistence.bean.base;


import java.util.Date;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsGestoriaVO;

/**
 * Base del VO cont els atributs de la entitat Gestoria 
 * @author dferri
 *
 */
public abstract class BaseGestoriaVO extends BaseVO implements ConstantsGestoriaVO {
	
	private static final long serialVersionUID = 1925366059056587189L;
	private int hashCode = -2147483648;

	//PK
	private String nif = null;
	
	//Fields
	private String 	nom 			= null;
	private String 	carrer 			= null;
	private String 	numero 			= null;
	private String 	resta 			= null;
	private String 	municipi 		= null;
	private String 	cp 				= null;
	private String 	nomComptable 	= null;
	private String 	nifComptable	= null;
	private String 	telefon 		= null;
	private String 	mail 			= null;
	private String 	comissio 		= null;	
	private Date	dataAlta 		= null;
	private Date 	dataModif 		= null;	
	
	/**
	 * Creador instancia
	 */
	public BaseGestoriaVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param nif
	 */
	public BaseGestoriaVO(String nif){
		this.nif = nif;
		initialize();
	}

	/**
	 * @return the nif
	 */
	public String getNif() {
		return nif;
	}

	/**
	 * @param nif the nif to set
	 */
	public void setNif(String nif) {
		this.nif = nif;
	}

	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}

	/**
	 * @return the carrer
	 */
	public String getCarrer() {
		return carrer;
	}

	/**
	 * @param carrer the carrer to set
	 */
	public void setCarrer(String carrer) {
		this.carrer = carrer;
	}

	/**
	 * @return the numero
	 */
	public String getNumero() {
		return numero;
	}

	/**
	 * @param numero the numero to set
	 */
	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * @return the resta
	 */
	public String getResta() {
		return resta;
	}

	/**
	 * @param resta the resta to set
	 */
	public void setResta(String resta) {
		this.resta = resta;
	}

	/**
	 * @return the municipi
	 */
	public String getMunicipi() {
		return municipi;
	}

	/**
	 * @param municipi the municipi to set
	 */
	public void setMunicipi(String municipi) {
		this.municipi = municipi;
	}

	/**
	 * @return the cp
	 */
	public String getCp() {
		return cp;
	}

	/**
	 * @param cp the cp to set
	 */
	public void setCp(String cp) {
		this.cp = cp;
	}

	/**
	 * @return the nomComptable
	 */
	public String getNomComptable() {
		return nomComptable;
	}

	/**
	 * @param nomComptable the nomComptable to set
	 */
	public void setNomComptable(String nomComptable) {
		this.nomComptable = nomComptable;
	}

	/**
	 * @return the nifComptable
	 */
	public String getNifComptable() {
		return nifComptable;
	}

	/**
	 * @param nifComptable the nifComptable to set
	 */
	public void setNifComptable(String nifComptable) {
		this.nifComptable = nifComptable;
	}

	/**
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}

	/**
	 * @param telefon the telefon to set
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	/**
	 * @return the mail
	 */
	public String getMail() {
		return mail;
	}

	/**
	 * @param mail the mail to set
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}

	/**
	 * @return the comissio
	 */
	public String getComissio() {
		return comissio;
	}

	/**
	 * @param comissio the comissio to set
	 */
	public void setComissio(String comissio) {
		this.comissio = comissio;
	}

	/**
	 * @return the dataAlta
	 */
	public Date getDataAlta() {
		return dataAlta;
	}

	/**
	 * @param dataAlta the dataAlta to set
	 */
	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}

	/**
	 * @return the dataModif
	 */
	public Date getDataModif() {
		return dataModif;
	}

	/**
	 * @param dataModif the dataModif to set
	 */
	public void setDataModif(Date dataModif) {
		this.dataModif = dataModif;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((carrer == null) ? 0 : carrer.hashCode());
		result = prime * result
				+ ((comissio == null) ? 0 : comissio.hashCode());
		result = prime * result + ((cp == null) ? 0 : cp.hashCode());
		result = prime * result
				+ ((dataAlta == null) ? 0 : dataAlta.hashCode());
		result = prime * result
				+ ((dataModif == null) ? 0 : dataModif.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((mail == null) ? 0 : mail.hashCode());
		result = prime * result
				+ ((municipi == null) ? 0 : municipi.hashCode());
		result = prime * result + ((nif == null) ? 0 : nif.hashCode());
		result = prime * result
				+ ((nifComptable == null) ? 0 : nifComptable.hashCode());
		result = prime * result + ((nom == null) ? 0 : nom.hashCode());
		result = prime * result
				+ ((nomComptable == null) ? 0 : nomComptable.hashCode());
		result = prime * result + ((numero == null) ? 0 : numero.hashCode());
		result = prime * result + ((resta == null) ? 0 : resta.hashCode());
		result = prime * result + ((telefon == null) ? 0 : telefon.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseGestoriaVO other = (BaseGestoriaVO) obj;
		if (carrer == null) {
			if (other.carrer != null)
				return false;
		} else if (!carrer.equals(other.carrer))
			return false;
		if (comissio == null) {
			if (other.comissio != null)
				return false;
		} else if (!comissio.equals(other.comissio))
			return false;
		if (cp == null) {
			if (other.cp != null)
				return false;
		} else if (!cp.equals(other.cp))
			return false;
		if (dataAlta == null) {
			if (other.dataAlta != null)
				return false;
		} else if (!dataAlta.equals(other.dataAlta))
			return false;
		if (dataModif == null) {
			if (other.dataModif != null)
				return false;
		} else if (!dataModif.equals(other.dataModif))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (mail == null) {
			if (other.mail != null)
				return false;
		} else if (!mail.equals(other.mail))
			return false;
		if (municipi == null) {
			if (other.municipi != null)
				return false;
		} else if (!municipi.equals(other.municipi))
			return false;
		if (nif == null) {
			if (other.nif != null)
				return false;
		} else if (!nif.equals(other.nif))
			return false;
		if (nifComptable == null) {
			if (other.nifComptable != null)
				return false;
		} else if (!nifComptable.equals(other.nifComptable))
			return false;
		if (nom == null) {
			if (other.nom != null)
				return false;
		} else if (!nom.equals(other.nom))
			return false;
		if (nomComptable == null) {
			if (other.nomComptable != null)
				return false;
		} else if (!nomComptable.equals(other.nomComptable))
			return false;
		if (numero == null) {
			if (other.numero != null)
				return false;
		} else if (!numero.equals(other.numero))
			return false;
		if (resta == null) {
			if (other.resta != null)
				return false;
		} else if (!resta.equals(other.resta))
			return false;
		if (telefon == null) {
			if (other.telefon != null)
				return false;
		} else if (!telefon.equals(other.telefon))
			return false;
		return true;
	}

}
	
