package com.ferri.persistence.bean.base;


import java.util.Date;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsIntervencioVO;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.ContracteVO;
import com.ferri.persistence.bean.impl.EstatVO;

/**
 * Base del VO cont els atributs de la entitat Intervencio 
 * @author dferri
 *
 */
public abstract class BaseIntervencioVO extends BaseVO implements ConstantsIntervencioVO{
	
	private static final long serialVersionUID = -5644641069491164470L;
	private int hashCode = -2147483648;

	//PK
	private Long id = null;
	
	//Fields
	private Integer		mes 			= null;
	private Integer		any 			= null;
	private Date		dataIntervencio	= null;	
	private ContracteVO	contracte 		= null;
	private ClientVO 	client  		= null;
	private EstatVO 	estat 			= null;
	
	/**
	 * Creador instancia
	 */
	public BaseIntervencioVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param id
	 */
	public BaseIntervencioVO(Long id){
		this.id = id;
		initialize();
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the mes
	 */
	public Integer getMes() {
		return mes;
	}

	/**
	 * @param mes the mes to set
	 */
	public void setMes(Integer mes) {
		this.mes = mes;
	}

	/**
	 * @return the dataIntervencio
	 */
	public Date getDataIntervencio() {
		return dataIntervencio;
	}

	/**
	 * @param dataIntervencio the dataIntervencio to set
	 */
	public void setDataIntervencio(Date dataIntervencio) {
		this.dataIntervencio = dataIntervencio;
	}

	/**
	 * @return the contracte
	 */
	public ContracteVO getContracte() {
		return contracte;
	}

	/**
	 * @param contracte the contracte to set
	 */
	public void setContracte(ContracteVO contracte) {
		this.contracte = contracte;
	}

	/**
	 * @return the client
	 */
	public ClientVO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientVO client) {
		this.client = client;
	}

	/**
	 * @return the estat
	 */
	public EstatVO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatVO estat) {
		this.estat = estat;
	}

	/**
	 * @return the any
	 */
	public Integer getAny() {
		return any;
	}

	/**
	 * @param any the any to set
	 */
	public void setAny(Integer any) {
		this.any = any;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((any == null) ? 0 : any.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result
				+ ((contracte == null) ? 0 : contracte.hashCode());
		result = prime * result
				+ ((dataIntervencio == null) ? 0 : dataIntervencio.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((mes == null) ? 0 : mes.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseIntervencioVO other = (BaseIntervencioVO) obj;
		if (any == null) {
			if (other.any != null)
				return false;
		} else if (!any.equals(other.any))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (contracte == null) {
			if (other.contracte != null)
				return false;
		} else if (!contracte.equals(other.contracte))
			return false;
		if (dataIntervencio == null) {
			if (other.dataIntervencio != null)
				return false;
		} else if (!dataIntervencio.equals(other.dataIntervencio))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (mes == null) {
			if (other.mes != null)
				return false;
		} else if (!mes.equals(other.mes))
			return false;
		return true;
	}
}
	
