package com.ferri.persistence.bean.base;


import java.util.Date;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsPressupostVO;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.FacturaVO;

/**
 * Base del VO cont els atributs de la entitat Pressupost 
 * @author dferri
 *
 */
public abstract class BasePressupostVO extends BaseVO implements ConstantsPressupostVO{
	
	private static final long serialVersionUID = 1345369677413457324L;
	private int hashCode = -2147483648;

	//PK
	private String numPressupost = null;
	
	//Fields
	private Date 		data 			= null;
	private Double 		baseImponible	= null;
	private String 		concepte 		= null;
	private String 		motiuCancel		= null;
	private Date 		dataModif 		= null;
	private EstatVO 	estat 			= null;
	private ClientVO 	client 			= null;
	private FacturaVO 	factura 		= null;
	
	/**
	 * Creador instancia
	 */
	public BasePressupostVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param numPressupost
	 */
	public BasePressupostVO(String numPressupost){
		this.numPressupost = numPressupost;
		initialize();
	}

	/**
	 * @return the numPressupost
	 */
	public String getNumPressupost() {
		return numPressupost;
	}

	/**
	 * @param numPressupost the numPressupost to set
	 */
	public void setNumPressupost(String numPressupost) {
		this.numPressupost = numPressupost;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the baseImponible
	 */
	public Double getBaseImponible() {
		return baseImponible;
	}

	/**
	 * @param baseImponible the baseImponible to set
	 */
	public void setBaseImponible(Double baseImponible) {
		this.baseImponible = baseImponible;
	}

	/**
	 * @return the concepte
	 */
	public String getConcepte() {
		return concepte;
	}

	/**
	 * @param concepte the concepte to set
	 */
	public void setConcepte(String concepte) {
		this.concepte = concepte;
	}

	/**
	 * @return the dataModif
	 */
	public Date getDataModif() {
		return dataModif;
	}

	/**
	 * @param dataModif the dataModif to set
	 */
	public void setDataModif(Date dataModif) {
		this.dataModif = dataModif;
	}

	/**
	 * @return the estat
	 */
	public EstatVO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatVO estat) {
		this.estat = estat;
	}

	/**
	 * @return the client
	 */
	public ClientVO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientVO client) {
		this.client = client;
	}

	/**
	 * @return the factura
	 */
	public FacturaVO getFactura() {
		return factura;
	}

	/**
	 * @param factura the factura to set
	 */
	public void setFactura(FacturaVO factura) {
		this.factura = factura;
	}

	/**
	 * @return the motiuCancel
	 */
	public String getMotiuCancel() {
		return motiuCancel;
	}

	/**
	 * @param motiuCancel the motiuCancel to set
	 */
	public void setMotiuCancel(String motiuCancel) {
		this.motiuCancel = motiuCancel;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((baseImponible == null) ? 0 : baseImponible.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result
				+ ((concepte == null) ? 0 : concepte.hashCode());
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		result = prime * result
				+ ((dataModif == null) ? 0 : dataModif.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + ((factura == null) ? 0 : factura.hashCode());
		result = prime * result + hashCode;
		result = prime * result
				+ ((motiuCancel == null) ? 0 : motiuCancel.hashCode());
		result = prime * result
				+ ((numPressupost == null) ? 0 : numPressupost.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BasePressupostVO other = (BasePressupostVO) obj;
		if (baseImponible == null) {
			if (other.baseImponible != null)
				return false;
		} else if (!baseImponible.equals(other.baseImponible))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (concepte == null) {
			if (other.concepte != null)
				return false;
		} else if (!concepte.equals(other.concepte))
			return false;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		if (dataModif == null) {
			if (other.dataModif != null)
				return false;
		} else if (!dataModif.equals(other.dataModif))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (factura == null) {
			if (other.factura != null)
				return false;
		} else if (!factura.equals(other.factura))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (motiuCancel == null) {
			if (other.motiuCancel != null)
				return false;
		} else if (!motiuCancel.equals(other.motiuCancel))
			return false;
		if (numPressupost == null) {
			if (other.numPressupost != null)
				return false;
		} else if (!numPressupost.equals(other.numPressupost))
			return false;
		return true;
	}

}
	
