package com.ferri.persistence.bean.base;

import com.ferri.core.vo.commons.BaseVO;
import com.ferri.persistence.bean.constants.ConstantsTipusPeriodeVO;

/**
 * Base del VO cont els atributs de la entitat TipusPeriode 
 * @author dferri
 *
 */
public abstract class BaseTipusPeriodeVO extends BaseVO implements ConstantsTipusPeriodeVO{
	
	private static final long serialVersionUID = 1353860322844623646L;
	private int hashCode = -2147483648;

	//PK
	private Long id = null;
	
	//Fields
	private String descCa = null;
	private String descEs = null;
	
	/**
	 * Creador instancia
	 */
	public BaseTipusPeriodeVO(){
		initialize();
	}

	/**
	 * Creador instancia
	 * @param id
	 */
	public BaseTipusPeriodeVO(Long id){
		this.id = id;
		initialize();
	}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the descCa
	 */
	public String getDescCa() {
		return descCa;
	}

	/**
	 * @param descCa the descCa to set
	 */
	public void setDescCa(String descCa) {
		this.descCa = descCa;
	}

	/**
	 * @return the descEs
	 */
	public String getDescEs() {
		return descEs;
	}

	/**
	 * @param descEs the descEs to set
	 */
	public void setDescEs(String descEs) {
		this.descEs = descEs;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((descCa == null) ? 0 : descCa.hashCode());
		result = prime * result + ((descEs == null) ? 0 : descEs.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		BaseTipusPeriodeVO other = (BaseTipusPeriodeVO) obj;
		if (descCa == null) {
			if (other.descCa != null)
				return false;
		} else if (!descCa.equals(other.descCa))
			return false;
		if (descEs == null) {
			if (other.descEs != null)
				return false;
		} else if (!descEs.equals(other.descEs))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		return true;
	}
	
}
	
