package com.ferri.persistence.bean.constants;

/**
 * Contants de l'entitat Estat
 * Hi ha 4 tipus d'estat depenent per quina entitat es fa servir: Factura, Pressupost, Contracte i Intervencio.
 * @author dferri
 *
 */
public abstract interface ConstantsEstatVO {
	public static final String PREFIX_FACTURA 		= "Fa";
	public static final String PREFIX_PRESSUPOST	= "Pr";
	public static final String PREFIX_CONTRACTE		= "Co";
	public static final String PREFIX_INTERVENCIO	= "In";	
	
	public Long	FACTURA_PENDENT			= 1L;
	public Long	FACTURA_ENVIADA			= 2L;
	public Long	FACTURA_COBRADA			= 3L;
	public Long	PRESSUPOST_PENDENT		= 4L;
	public Long	PRESSUPOST_ENVIAT		= 5L;
	public Long	PRESSUPOST_ACCEPTAT		= 6L;
	public Long	PRESSUPOST_DENEGAT		= 7L;
	public Long	CONTRACTE_PENDENT		= 8L;
	public Long	CONTRACTE_ENVIAT		= 9L;
	public Long	CONTRACTE_SIGNAT		= 10L;
	public Long	INTERVENCIO_PENDENT		= 11L;
	public Long	INTERVENCIO_REALITZADA	= 12L;
}

