package com.ferri.persistence.dao.impl;

import java.util.Calendar;
import java.util.List;

import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.dao.base.BaseClientDAO;
import com.ferri.portlet.utils.Format;

/**
 * Implementaci DAO de la instancia Client
 * @author dferri
 *
 */
public class ClientDAOImpl extends BaseClientDAO
{
	/**
	 * 
	 */
	public Integer getSemaforEstatFactures(String nifClient){
		try{
			
			Calendar haceUnMes = Calendar.getInstance();
			haceUnMes.add(Calendar.MONTH, -1);
			
			StringBuffer query = new StringBuffer();
			query.append(" select count(*) from tfc_factura fac where fac.nif_client = '").append(nifClient).append("'") ;
			query.append(" and fac.estat is not null ");
			query.append(" and fac.estat <> ").append(EstatVO.FACTURA_COBRADA);
			query.append(" and fac.data < '").append(Format.DATE_FORMAT_MYSQL.format(haceUnMes.getTime())).append("'");
			
			List result = getSession().createSQLQuery(query.toString()).list();

			Integer next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_ROJO;
			}
			
			
			StringBuffer query2 = new StringBuffer();
			query2.append(" select count(*) from tfc_factura fac where fac.nif_client = '").append(nifClient).append("'") ;
			query2.append(" and fac.estat is not null ");
			query2.append(" and fac.estat <> ").append(EstatVO.FACTURA_COBRADA);

			result = getSession().createSQLQuery(query2.toString()).list();

			next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_AMBAR;
			}

			StringBuffer query3 = new StringBuffer();
			query3.append(" select count(*) from tfc_factura fac where fac.nif_client = '").append(nifClient).append("'") ;			
			query3.append(" and fac.estat = ").append(EstatVO.FACTURA_COBRADA);

			result = getSession().createSQLQuery(query3.toString()).list();

			next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_VERDE;
			}
			
			return ClientVO.SEMAFORO_APAGADO;
			
		}catch(Exception e){
			e.printStackTrace();
			getSession().getTransaction().rollback();
			return null;
		}
	}
	
	/**
	 * 
	 */
	public Integer getSemaforEstatIntervencions(String nifClient){
		try{
			
			Calendar haceUnMes = Calendar.getInstance();
			haceUnMes.add(Calendar.MONTH, -1);
			
			StringBuffer query = new StringBuffer();
			query.append(" select count(*) from tfc_intervencio inte where inte.nif_client = '").append(nifClient).append("'") ;
			query.append(" and inte.estat <> ").append(EstatVO.INTERVENCIO_REALITZADA);
			query.append(" and CONCAT(inte.any , LPAD(inte.mes, 2,'0')) <= ").append(Format.ANY_MES_FORMAT.format(haceUnMes.getTime()));
			
			List result = getSession().createSQLQuery(query.toString()).list();

			Integer next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_ROJO;
			}
			
			
			StringBuffer query2 = new StringBuffer();
			query2.append(" select count(*) from tfc_intervencio inte where inte.nif_client = '").append(nifClient).append("'") ;
			query2.append(" and inte.estat <> ").append(EstatVO.INTERVENCIO_REALITZADA);

			result = getSession().createSQLQuery(query2.toString()).list();

			next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_AMBAR;
			}

			StringBuffer query3 = new StringBuffer();
			query3.append(" select count(*) from tfc_intervencio inte where inte.nif_client = '").append(nifClient).append("'") ;
			query3.append(" and inte.estat = ").append(EstatVO.INTERVENCIO_REALITZADA);

			result = getSession().createSQLQuery(query3.toString()).list();

			next = ((Number) result.get(0)).intValue();

			if(next >= 1){
				return ClientVO.SEMAFORO_VERDE;
			}
			
			return ClientVO.SEMAFORO_APAGADO;
			
		}catch(Exception e){
			e.printStackTrace();
			getSession().getTransaction().rollback();
			return null;
		}
	}
}

