package com.ferri.persistence.dao.impl;

import java.util.List;

import com.ferri.persistence.bean.impl.ContadorVO;
import com.ferri.persistence.dao.base.BaseContadorDAO;
import com.ferri.portlet.utils.Format;

/**
 * Implementaci DAO de la instancia Contador
 * @author dferri
 *
 */
public class ContadorDAOImpl extends BaseContadorDAO
{
	/**
	 * Metode que retorna el seguent nmero de la taula tfc_contador amb autoincrement crivat per any i tipus(factura, pressupost i contracte).
	 * S'ha fet aix ja que no es pot configurar el mapeig hibernate per una clau composta amb una de les columnes amb autoincrement.
	 * @param tipus
	 * @return String segent nmero
	 */
	public String nextNumero(String tipus){
		try{
			Integer anyActual = Format.getAnyActual();
			StringBuffer query = new StringBuffer();
			query.append("select nextNumero(").append(anyActual).append(",'").append(tipus).append("')");
			List result = getSession().createSQLQuery(query.toString()).list();

			Integer next = (Integer) result.get(0);

			return tipus + anyActual.toString() + Format.NUMERACIO_FORMAT.format(next);
			
		}catch(Exception e){
			e.printStackTrace();
			getSession().getTransaction().rollback();
			return null;
		}
	}

	public String nextNumeroFactura() {		
		return nextNumero(ContadorVO.TIPUS_FACTURA);
	}
	public String nextNumeroContracte() {		
		return nextNumero(ContadorVO.TIPUS_CONTRACTE);
	}
	public String nextNumeroPressupost() {		
		return nextNumero(ContadorVO.TIPUS_PRESSUPOST);
	}
}

