package com.ferri.persistence.dao.interfaces;

import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.dao.commons.GenericBaseDAO;

/**
 * Interficie DAO per la entitat Client
 * @author dferri
 *
 */
public abstract interface ClientDAO extends GenericBaseDAO<ClientVO, String>{
	/**
	 * Metode que calcla l'estat de les intervencions d'un client. 
	 * Retorna verd si totes estn finalitzades, ambar si en queden pendents, vermell si n'hi han a punt de vencer en data. 
	 * @param nifClient
	 * @return Integer amb el valor de constant del color
	 */
	public Integer getSemaforEstatIntervencions(String nifClient);
	
	/**
	 * Metode que calcla l'estat de les factures d'un client. 
	 * Retorna verd si totes estn pagades, ambar si en queden pendents, vermell si n'hi han pendents amb data antiga. 
	 * @param nifClient
	 * @return Integer amb el valor de constant del color
	 */
	public Integer getSemaforEstatFactures(String nifClient);
}
