package com.ferri.persistence.dao.interfaces;

import com.ferri.persistence.bean.impl.ContadorVO;
import com.ferri.persistence.dao.commons.GenericBaseDAO;

/**
 * Interficie DAO per la entitat Contador
 * @author dferri
 *
 */
public abstract interface ContadorDAO extends GenericBaseDAO<ContadorVO, Object[]>
{
	/**
	 * Recupera el segent numero de factura tenint en compte l'any actual.
	 * @return String segent nmero
	 */
	public String nextNumeroFactura();
	
	/**
	 * Recupera el segent numero de contracte tenint en compte l'any actual.
	 * @return String segent nmero
	 */
	public String nextNumeroContracte();
	
	/**
	 * Recupera el segent numero de pressupost tenint en compte l'any actual.
	 * @return String segent nmero
	 */
	public String nextNumeroPressupost();		
}
