package com.ferri.persistence.dao.interfaces;

import com.ferri.persistence.bean.impl.GestoriaVO;
import com.ferri.persistence.dao.commons.GenericBaseDAO;

/**
 * Interficie DAO per la entitat Gestoria
 * @author dferri
 *
 */
public abstract interface GestoriaDAO extends GenericBaseDAO<GestoriaVO, String> {
	/**
	 * Compta els clients associats a una Gestoria
	 * @param nif
	 * @return Integer
	 */
	public Integer countClients(String nif);
	
	/**
	 * Compta els administradors pertanyents a una Gestoria
	 * @param nif
	 * @return Integer
	 */
	public Integer countAdrministradors(String nif);
}
