package com.ferri.portlet.utils;

import java.text.DecimalFormat;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * Classe que engloba mscares de dates i nmeriques, amb alguns metodes de format de dates i chekeig de nulls.
 * @author dferri
 *
 */
public class Format {

	public static final String MASCARA_DATA 		= "dd/MM/yyyy";
	public static final String MASCARA_DATA_MYSQL	= "yyyy-MM-dd";
	public static final String MASCARA_MES			= "MM";
	public static final String MASCARA_ANY 			= "yyyy";
	public static final String MASCARA_MES2			= "MMMMM";
	
	public static final String MASCARA_NUMERACIO 	= "0000";
	public static final String MASCARA_NUMERACIO2 	= "00";	
	public static final String DEFAULT_DIA			= "01/";
	public static final String MASCARA_IMPORTS		= "#####0.00";
	
	
	public static final SimpleDateFormat DATE_FORMAT 			= new SimpleDateFormat(MASCARA_DATA);
	public static final SimpleDateFormat DATE_FORMAT_MYSQL		= new SimpleDateFormat(MASCARA_DATA_MYSQL);
	public static final SimpleDateFormat MES_FORMAT				= new SimpleDateFormat(MASCARA_MES);	
	public static final SimpleDateFormat ANY_FORMAT 			= new SimpleDateFormat(MASCARA_ANY);
	public static final SimpleDateFormat ANY_MES_FORMAT			= new SimpleDateFormat(MASCARA_ANY+MASCARA_MES);
	public static final DecimalFormat NUMERACIO_FORMAT 			= new DecimalFormat(MASCARA_NUMERACIO);
	public static final DecimalFormat IMPORTS_FORMAT 			= new DecimalFormat(MASCARA_IMPORTS);
	
	
	public static final DecimalFormat NUMERACIO_FORMAT2 		= new DecimalFormat(MASCARA_NUMERACIO2);
	
	public static final Integer VALOR_MINIM_NUMERACIO = 100;
	
	/**
	 * Dona format String a una data no nula
	 * @param data
	 * @return
	 */
	public static final String date2String(Date data){
		String result = "";
		try{
			result = DATE_FORMAT.format(data);
		}catch(Exception e){}
		
		return result;
	}
	
	/**
	 * Crea una data a partir d'un String
	 * @param data
	 * @return
	 */
	public static final Date string2Date(String data){
		Date result = null;
		try{
			result = DATE_FORMAT.parse(data);
		}catch(Exception e){}
		
		return result;
	}
	
	/**
	 * Controla si un String es null i treu espais en blanc.
	 * @param parameter
	 * @return
	 */
	public static final String checkNull(Object parameter){
		if(parameter == null){
			return "";
		}		
		return parameter.toString().trim();
	}
	
	/**
	 * Retorna l'any actual.
	 * @return
	 */
	public static final Integer getAnyActual(){
		Date today = new Date(System.currentTimeMillis()); 
		String anyS = ANY_FORMAT.format(today);
		return Integer.parseInt(anyS);
	}
	
}
