package com.ferri.portlet.utils;

import java.text.MessageFormat;
import java.util.Locale;
import java.util.MissingResourceException;
import java.util.ResourceBundle;

public class MessageResourceBundle {
	private static final String BUNDLE_NAME = "missatges";

	private static final ResourceBundle RESOURCE_BUNDLE = ResourceBundle.getBundle(BUNDLE_NAME);

	private MessageResourceBundle() {
	}

	public static String getString(String key) {
		// TODO Auto-generated method stub
		try {
			
			return RESOURCE_BUNDLE.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	
	
	public static String getString(String key, Locale locale) {
		// TODO Auto-generated method stub
		try {
			
			ResourceBundle bundle = ResourceBundle.getBundle(BUNDLE_NAME, locale);
			
			return bundle.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	
	public static String getString(String key, Locale locale, Object[] args) {
		// TODO Auto-generated method stub
		try {
			
			ResourceBundle bundle = ResourceBundle.getBundle(BUNDLE_NAME, locale);
			MessageFormat formatter = new MessageFormat("");
			formatter.setLocale(locale);
			
			formatter.applyPattern(bundle.getString(key));
			
			return formatter.format(args);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}	
	
	public static String getString(String bundleName, String key, Locale locale) {
		// TODO Auto-generated method stub
		try {
			
			ResourceBundle RscBundle = ResourceBundle.getBundle(bundleName, locale);
			
			return RscBundle.getString(key);
		} catch (MissingResourceException e) {
			return '!' + key + '!';
		}
	}
	
}
