package com.ferri.portlet.utils;

import java.util.ArrayList;

/**
 * Contenedor dels missatges de processos en els controladors, que apareixen per pantalla d'usuari.
 * @author dferri
 *
 */
public class Missatge {

	public static final Integer TYPE_ERROR 	= 1;
	public static final Integer TYPE_SUCCES	= 2;
	public static final Integer TYPE_INFO	= 3;
	
	private String key = null;
	private Integer type = null;
	private String[] args = null;
	
	/**
	 * Creaci Missatge
	 * @param type
	 * @param msg
	 */
	public Missatge(Integer type, String msg){
		this.key = msg;
		this.type = type;
	}

	/**
	 * Creaci Missatge
	 * @param type
	 * @param msg
	 * @param args
	 */
	public Missatge(Integer type, String msg, String[] args){
		this.key = msg;
		this.type = type;
		this.args = args;
	}
	
	/**
	 * @return the key
	 */
	public String getKey() {
		return key;
	}
	/**
	 * @param key the key to set
	 */
	public void setKey(String key) {
		this.key = key;
	}
	/**
	 * @return the type
	 */
	public Integer getType() {
		return type;
	}
	/**
	 * @param type the type to set
	 */
	public void setType(Integer type) {
		this.type = type;
	}

	/**
	 * @return the args
	 */
	public String[] getArgs() {
		return args;
	}

	/**
	 * @param args the args to set
	 */
	public void setArgs(String[] args) {
		this.args = args;
	}

	/**
	 * Afegeix entitats Missatge al ArrayList missatges 
	 * @param key
	 * @param type
	 * @param missatges
	 * @return
	 */
	public static final ArrayList<Missatge> addMissatge(String key, Integer type, ArrayList<Missatge> missatges){
		if(missatges == null){
			missatges = new ArrayList<Missatge>();
		}
		missatges.add(new Missatge(type, key));
		return missatges;		
	}
	
	/**
	 * Afegeix entitats Missatge al ArrayList missatges
	 * @param key
	 * @param type
	 * @return
	 */
	public static final ArrayList<Missatge> addMissatge(String key, Integer type){
		return addMissatge(key, type, null);
	}
	
}
