package com.ferri.service.dto;

import com.ferri.core.vo.commons.BaseDTO;

import java.util.Date;

/**
 * Implementaci de la instancia DTO. Taula: tfc_administrador	 
 * @author dferri
 *
 */
public class AdministradorDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	
	//PK
	private String nif = null;
	
	//Fields
	private String 		nom = null;	
	private String 		telefon = null;
	private String 		mail = null;	
	private Date 		dataAlta = null;
	private Date 		dataModif = null;	
	private GestoriaDTO 	gestoria = null;
	
	//Extra
	private String ordre = null;
	private String validationNif	= null;
	
	private Integer numClients 		= null;

	/**
	 * Creador instancia
	 * @param nif
	 * @param nom
	 * @param telefon
	 * @param mail
	 * @param dataAlta
	 * @param dataModif
	 * @param gestoria
	 */
	public AdministradorDTO(String nif, String nom, String telefon, String mail, Date 		dataAlta, Date 		dataModif, 	GestoriaDTO 	gestoria){
		this.setNif(nif);
		this.setNom(nom);	
		this.setTelefon(telefon);
		this.setMail(mail);	
		this.setDataAlta(dataAlta);
		this.setDataModif(dataModif);	
		this.setGestoria(gestoria);
	}

	/**
	 * Creador instancia
	 * @param nom
	 * @param telefon
	 * @param mail
	 * @param dataAlta
	 * @param dataModif
	 * @param gestoria
	 */
	public AdministradorDTO(String nom, String telefon, String mail, Date 		dataAlta, Date 		dataModif, 	GestoriaDTO 	gestoria){
		this.setNom(nom);	
		this.setTelefon(telefon);
		this.setMail(mail);	
		this.setDataAlta(dataAlta);
		this.setDataModif(dataModif);	
		this.setGestoria(gestoria);
	}
	
	/**
	 * Creador instancia
	 */
	public AdministradorDTO(){}

	/**
	 * @return the nif
	 */
	public String getNif() {
		return nif;
	}

	/**
	 * @param nif the nif to set
	 */
	public void setNif(String nif) {
		this.nif = nif;
	}

	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}

	/**
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}

	/**
	 * @param telefon the telefon to set
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	/**
	 * @return the mail
	 */
	public String getMail() {
		return mail;
	}

	/**
	 * @param mail the mail to set
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}

	/**
	 * @return the dataAlta
	 */
	public Date getDataAlta() {
		return dataAlta;
	}

	/**
	 * @param dataAlta the dataAlta to set
	 */
	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}

	/**
	 * @return the dataModif
	 */
	public Date getDataModif() {
		return dataModif;
	}

	/**
	 * @param dataModif the dataModif to set
	 */
	public void setDataModif(Date dataModif) {
		this.dataModif = dataModif;
	}

	/**
	 * @return the gestoria
	 */
	public GestoriaDTO getGestoria() {
		return gestoria;
	}

	/**
	 * @param gestoria the gestoria to set
	 */
	public void setGestoria(GestoriaDTO gestoria) {
		this.gestoria = gestoria;
	}

	
	/**
	 * @return the ordre
	 */
	public String getOrdre() {
		return ordre;
	}

	/**
	 * @param ordre the ordre to set
	 */
	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}
	

	/**
	 * @return the validationNif
	 */
	public String getValidationNif() {
		return validationNif;
	}

	/**
	 * @param validationNif the validationNif to set
	 */
	public void setValidationNif(String validationNif) {
		this.validationNif = validationNif;
	}

	/**
	 * @return the numClients
	 */
	public Integer getNumClients() {
		return numClients;
	}

	/**
	 * @param numClients the numClients to set
	 */
	public void setNumClients(Integer numClients) {
		this.numClients = numClients;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((dataAlta == null) ? 0 : dataAlta.hashCode());
		result = prime * result
				+ ((dataModif == null) ? 0 : dataModif.hashCode());
		result = prime * result
				+ ((gestoria == null) ? 0 : gestoria.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((mail == null) ? 0 : mail.hashCode());
		result = prime * result + ((nif == null) ? 0 : nif.hashCode());
		result = prime * result + ((nom == null) ? 0 : nom.hashCode());
		result = prime * result + ((telefon == null) ? 0 : telefon.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		AdministradorDTO other = (AdministradorDTO) obj;
		if (dataAlta == null) {
			if (other.dataAlta != null)
				return false;
		} else if (!dataAlta.equals(other.dataAlta))
			return false;
		if (dataModif == null) {
			if (other.dataModif != null)
				return false;
		} else if (!dataModif.equals(other.dataModif))
			return false;
		if (gestoria == null) {
			if (other.gestoria != null)
				return false;
		} else if (!gestoria.equals(other.gestoria))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (mail == null) {
			if (other.mail != null)
				return false;
		} else if (!mail.equals(other.mail))
			return false;
		if (nif == null) {
			if (other.nif != null)
				return false;
		} else if (!nif.equals(other.nif))
			return false;
		if (nom == null) {
			if (other.nom != null)
				return false;
		} else if (!nom.equals(other.nom))
			return false;
		if (telefon == null) {
			if (other.telefon != null)
				return false;
		} else if (!telefon.equals(other.telefon))
			return false;
		return true;
	}
	
}
