package com.ferri.service.dto;

import com.ferri.core.vo.commons.BaseDTO;

import java.util.Date;

/**
 * Implementaci de la instancia DTO. Taula: tfc_client
 * @author dferri
 *
 */
public class ClientDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	//PK
	private String nif = null;
	
	//Fields
	private String 				nom 			= null;
	private String 				carrer 			= null;
	private String 				numero 			= null;
	private String 				resta 			= null;
	private String 				municipi 		= null;
	private String 				cp 				= null;
	private String 				telefon 		= null;
	private String 				mail 			= null;	
	private Date 				dataAlta 		= null;
	private Date 				dataModif 		= null;	
	private GestoriaDTO			gestoria		= null;
	private AdministradorDTO	administrador 	= null;
	private TipusClientDTO 		tipusClient		= null;
	
	//Extra
	private String ordre = null;
	private String validationNif	= null;
	
	private Integer colorSemaforFactura = null;
	private Integer colorSemaforIntervencio = null;
	
	/**
	 * Creador instancia
	 * @param nif
	 * @param nom
	 * @param carrer
	 * @param numero
	 * @param resta
	 * @param municipi
	 * @param cp
	 * @param telefon
	 * @param mail
	 * @param dataAlta
	 * @param dataModif
	 * @param gestoria
	 * @param administrador
	 * @param tipusClient
	 */
	public ClientDTO(	String nif,
						String 				nom,
						String 				carrer,
						String 				numero,
						String 				resta,
						String 				municipi,
						String 				cp,
						String 				telefon,
						String 				mail,	
						Date 				dataAlta,
						Date 				dataModif,	
						GestoriaDTO			gestoria,
						AdministradorDTO	administrador,
						TipusClientDTO 		tipusClient) {		
		this.setNif(nif);
		this.setNom(nom);
		this.setCarrer(carrer);
		this.setNumero(numero);
		this.setResta(resta);
		this.setMunicipi(municipi);
		this.setCp(cp);
		this.setTelefon(telefon);
		this.setMail(mail);	
		this.setDataAlta(dataAlta);
		this.setDataModif(dataModif);	
		this.setGestoria(gestoria);
		this.setAdministrador(administrador);
		this.setTipusClient(tipusClient);
	}

	/**
	 * Creador instancia
	 * @param nom
	 * @param carrer
	 * @param numero
	 * @param resta
	 * @param municipi
	 * @param cp
	 * @param telefon
	 * @param mail
	 * @param dataAlta
	 * @param dataModif
	 * @param gestoria
	 * @param administrador
	 * @param tipusClient
	 */
	public ClientDTO(	String 				nom,
						String 				carrer,
						String 				numero,
						String 				resta,
						String 				municipi,
						String 				cp,
						String 				telefon,
						String 				mail,	
						Date 				dataAlta,
						Date 				dataModif,	
						GestoriaDTO			gestoria,
						AdministradorDTO	administrador,
						TipusClientDTO 		tipusClient) {		
		this.setNom(nom);
		this.setCarrer(carrer);
		this.setNumero(numero);
		this.setResta(resta);
		this.setMunicipi(municipi);
		this.setCp(cp);
		this.setTelefon(telefon);
		this.setMail(mail);	
		this.setDataAlta(dataAlta);
		this.setDataModif(dataModif);	
		this.setGestoria(gestoria);
		this.setAdministrador(administrador);
		this.setTipusClient(tipusClient);
	}
	
	/**
	 * Creador instancia
	 */
	public ClientDTO(){}

	/**
	 * @return the nif
	 */
	public String getNif() {
		return nif;
	}

	/**
	 * @param nif the nif to set
	 */
	public void setNif(String nif) {
		this.nif = nif;
	}

	/**
	 * @return the nom
	 */
	public String getNom() {
		return nom;
	}

	/**
	 * @param nom the nom to set
	 */
	public void setNom(String nom) {
		this.nom = nom;
	}

	/**
	 * @return the carrer
	 */
	public String getCarrer() {
		return carrer;
	}

	/**
	 * @param carrer the carrer to set
	 */
	public void setCarrer(String carrer) {
		this.carrer = carrer;
	}

	/**
	 * @return the numero
	 */
	public String getNumero() {
		return numero;
	}

	/**
	 * @param numero the numero to set
	 */
	public void setNumero(String numero) {
		this.numero = numero;
	}

	/**
	 * @return the resta
	 */
	public String getResta() {
		return resta;
	}

	/**
	 * @param resta the resta to set
	 */
	public void setResta(String resta) {
		this.resta = resta;
	}

	/**
	 * @return the municipi
	 */
	public String getMunicipi() {
		return municipi;
	}

	/**
	 * @param municipi the municipi to set
	 */
	public void setMunicipi(String municipi) {
		this.municipi = municipi;
	}

	/**
	 * @return the cp
	 */
	public String getCp() {
		return cp;
	}

	/**
	 * @param cp the cp to set
	 */
	public void setCp(String cp) {
		this.cp = cp;
	}

	/**
	 * @return the telefon
	 */
	public String getTelefon() {
		return telefon;
	}

	/**
	 * @param telefon the telefon to set
	 */
	public void setTelefon(String telefon) {
		this.telefon = telefon;
	}

	/**
	 * @return the mail
	 */
	public String getMail() {
		return mail;
	}

	/**
	 * @param mail the mail to set
	 */
	public void setMail(String mail) {
		this.mail = mail;
	}

	/**
	 * @return the dataAlta
	 */
	public Date getDataAlta() {
		return dataAlta;
	}

	/**
	 * @param dataAlta the dataAlta to set
	 */
	public void setDataAlta(Date dataAlta) {
		this.dataAlta = dataAlta;
	}

	/**
	 * @return the dataModif
	 */
	public Date getDataModif() {
		return dataModif;
	}

	/**
	 * @param dataModif the dataModif to set
	 */
	public void setDataModif(Date dataModif) {
		this.dataModif = dataModif;
	}

	/**
	 * @return the gestoria
	 */
	public GestoriaDTO getGestoria() {
		return gestoria;
	}

	/**
	 * @param gestoria the gestoria to set
	 */
	public void setGestoria(GestoriaDTO gestoria) {
		this.gestoria = gestoria;
	}

	/**
	 * @return the administrador
	 */
	public AdministradorDTO getAdministrador() {
		return administrador;
	}

	/**
	 * @param administrador the administrador to set
	 */
	public void setAdministrador(AdministradorDTO administrador) {
		this.administrador = administrador;
	}

	/**
	 * @return the tipusClient
	 */
	public TipusClientDTO getTipusClient() {
		return tipusClient;
	}

	/**
	 * @param tipusClient the tipusClient to set
	 */
	public void setTipusClient(TipusClientDTO tipusClient) {
		this.tipusClient = tipusClient;
	}

	
	/**
	 * @return the ordre
	 */
	public String getOrdre() {
		return ordre;
	}

	/**
	 * @param ordre the ordre to set
	 */
	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}

	/**
	 * @return the validationNif
	 */
	public String getValidationNif() {
		return validationNif;
	}

	/**
	 * @param validationNif the validationNif to set
	 */
	public void setValidationNif(String validationNif) {
		this.validationNif = validationNif;
	}
	

	/**
	 * @return the colorSemaforFactura
	 */
	public Integer getColorSemaforFactura() {
		return colorSemaforFactura;
	}

	/**
	 * @param colorSemaforFactura the colorSemaforFactura to set
	 */
	public void setColorSemaforFactura(Integer colorSemaforFactura) {
		this.colorSemaforFactura = colorSemaforFactura;
	}

	/**
	 * @return the colorSemaforIntervencio
	 */
	public Integer getColorSemaforIntervencio() {
		return colorSemaforIntervencio;
	}

	/**
	 * @param colorSemaforIntervencio the colorSemaforIntervencio to set
	 */
	public void setColorSemaforIntervencio(Integer colorSemaforIntervencio) {
		this.colorSemaforIntervencio = colorSemaforIntervencio;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((administrador == null) ? 0 : administrador.hashCode());
		result = prime * result + ((carrer == null) ? 0 : carrer.hashCode());
		result = prime * result + ((cp == null) ? 0 : cp.hashCode());
		result = prime * result
				+ ((dataAlta == null) ? 0 : dataAlta.hashCode());
		result = prime * result
				+ ((dataModif == null) ? 0 : dataModif.hashCode());
		result = prime * result
				+ ((gestoria == null) ? 0 : gestoria.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((mail == null) ? 0 : mail.hashCode());
		result = prime * result
				+ ((municipi == null) ? 0 : municipi.hashCode());
		result = prime * result + ((nif == null) ? 0 : nif.hashCode());
		result = prime * result + ((nom == null) ? 0 : nom.hashCode());
		result = prime * result + ((numero == null) ? 0 : numero.hashCode());
		result = prime * result + ((resta == null) ? 0 : resta.hashCode());
		result = prime * result + ((telefon == null) ? 0 : telefon.hashCode());
		result = prime * result
				+ ((tipusClient == null) ? 0 : tipusClient.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ClientDTO other = (ClientDTO) obj;
		if (administrador == null) {
			if (other.administrador != null)
				return false;
		} else if (!administrador.equals(other.administrador))
			return false;
		if (carrer == null) {
			if (other.carrer != null)
				return false;
		} else if (!carrer.equals(other.carrer))
			return false;
		if (cp == null) {
			if (other.cp != null)
				return false;
		} else if (!cp.equals(other.cp))
			return false;
		if (dataAlta == null) {
			if (other.dataAlta != null)
				return false;
		} else if (!dataAlta.equals(other.dataAlta))
			return false;
		if (dataModif == null) {
			if (other.dataModif != null)
				return false;
		} else if (!dataModif.equals(other.dataModif))
			return false;
		if (gestoria == null) {
			if (other.gestoria != null)
				return false;
		} else if (!gestoria.equals(other.gestoria))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (mail == null) {
			if (other.mail != null)
				return false;
		} else if (!mail.equals(other.mail))
			return false;
		if (municipi == null) {
			if (other.municipi != null)
				return false;
		} else if (!municipi.equals(other.municipi))
			return false;
		if (nif == null) {
			if (other.nif != null)
				return false;
		} else if (!nif.equals(other.nif))
			return false;
		if (nom == null) {
			if (other.nom != null)
				return false;
		} else if (!nom.equals(other.nom))
			return false;
		if (numero == null) {
			if (other.numero != null)
				return false;
		} else if (!numero.equals(other.numero))
			return false;
		if (resta == null) {
			if (other.resta != null)
				return false;
		} else if (!resta.equals(other.resta))
			return false;
		if (telefon == null) {
			if (other.telefon != null)
				return false;
		} else if (!telefon.equals(other.telefon))
			return false;
		if (tipusClient == null) {
			if (other.tipusClient != null)
				return false;
		} else if (!tipusClient.equals(other.tipusClient))
			return false;
		return true;
	}
	
}
