package com.ferri.service.dto;

import com.ferri.core.vo.commons.BaseDTO;

/**
 * Implementaci de la instancia DTO. Taula: tfc_constants
 * @author dferri
 *
 */
public class ConstantsDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	
	//PK
	private Long id = null;
	
	//Fields
	private Double valor = null;
	private String descCa = null;
	private String descEs = null;

	/**
	 * Creador instancia
	 * @param id
	 * @param descCa
	 * @param descEs
	 * @param valor
	 */
	public ConstantsDTO(Long id, String descCa, String descEs, Double valor) {		
		setId(id);
		setDescCa(descCa);
		setDescEs(descEs);
		setValor(valor);
	}

	/**
	 * Creador instancia
	 * @param descCa
	 * @param descEs
	 * @param valor
	 */
	public ConstantsDTO(String descCa, String descEs, Double valor) {		
		setDescCa(descCa);
		setDescEs(descEs);
		setValor(valor);
	}
	
	/**
	 * Creador instancia
	 */
	public ConstantsDTO(){}
	

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the descCa
	 */
	public String getDescCa() {
		return descCa;
	}

	/**
	 * @param descCa the descCa to set
	 */
	public void setDescCa(String descCa) {
		this.descCa = descCa;
	}

	/**
	 * @return the descEs
	 */
	public String getDescEs() {
		return descEs;
	}

	/**
	 * @param descEs the descEs to set
	 */
	public void setDescEs(String descEs) {
		this.descEs = descEs;
	}

	/**
	 * @return the valor
	 */
	public Double getValor() {
		return valor;
	}

	/**
	 * @param valor the valor to set
	 */
	public void setValor(Double valor) {
		this.valor = valor;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((descCa == null) ? 0 : descCa.hashCode());
		result = prime * result + ((descEs == null) ? 0 : descEs.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((valor == null) ? 0 : valor.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ConstantsDTO other = (ConstantsDTO) obj;
		if (descCa == null) {
			if (other.descCa != null)
				return false;
		} else if (!descCa.equals(other.descCa))
			return false;
		if (descEs == null) {
			if (other.descEs != null)
				return false;
		} else if (!descEs.equals(other.descEs))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (valor == null) {
			if (other.valor != null)
				return false;
		} else if (!valor.equals(other.valor))
			return false;
		return true;
	}

}
