package com.ferri.service.dto;

import java.util.Date;

import com.ferri.core.vo.commons.BaseDTO;
import com.ferri.portlet.utils.Format;

/**
 * Implementaci de la instancia DTO. Taula: tfc_contracte
 * @author dferri
 *
 */
public class ContracteDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	
	//PK
	private String numContracte = null;
	
	//Fields
	private Date 			data 			= null;	
	private Integer 		mesIni 			= null;
	private Double 			baseImponible	= null;
	private EstatDTO 		estat  			= null;
	private ClientDTO 		client  		= null;
	private TipusPeriodeDTO	tipusPeriode  	= null;
	private FacturaDTO 		factura			= null;
	
	//Extra
	private String ordre = null;
	private Date dataIni = null;
	private Date dataFin = null;
	
	private String dataIniS = null;
	private String dataFinS = null;
	
	//Extra Form
	private String baseImponibleS = null;	
	
	/**
	 * Creador instancia
	 * @param numContracte
	 * @param data
	 * @param mesIni
	 * @param baseImponible
	 * @param estat
	 * @param client
	 * @param tipusPeriode
	 * @param factura
	 */
	public ContracteDTO(String numContracte, Date data, Integer mesIni, Double baseImponible, EstatDTO estat, ClientDTO client, TipusPeriodeDTO	tipusPeriode, FacturaDTO 	factura) {		
		this.setNumContracte(numContracte);
		this.setData(data);		
		this.setMesIni(mesIni);
		this.setBaseImponible(baseImponible);
		this.setEstat(estat);
		this.setClient(client);
		this.setTipusPeriode(tipusPeriode);
		this.setFactura(factura); 
	}

	/**
	 * Creador instancia
	 * @param data
	 * @param mesIni
	 * @param baseImponible
	 * @param estat
	 * @param client
	 * @param tipusPeriode
	 * @param factura
	 */
	public ContracteDTO(Date data, Integer mesIni, Double baseImponible, EstatDTO estat, ClientDTO client, TipusPeriodeDTO	tipusPeriode, FacturaDTO 	factura) {		
		this.setNumContracte(numContracte);
		this.setData(data);		
		this.setMesIni(mesIni);
		this.setBaseImponible(baseImponible);
		this.setEstat(estat);
		this.setClient(client);
		this.setTipusPeriode(tipusPeriode);
		this.setFactura(factura); 
	}
	
	/**
	 * Creador instancia
	 */
	public ContracteDTO(){}

	/**
	 * @return the numContracte
	 */
	public String getNumContracte() {
		return numContracte;
	}

	/**
	 * @param numContracte the numContracte to set
	 */
	public void setNumContracte(String numContracte) {
		this.numContracte = numContracte;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the mesIni
	 */
	public Integer getMesIni() {
		return mesIni;
	}

	/**
	 * @param mesIni the mesIni to set
	 */
	public void setMesIni(Integer mesIni) {
		this.mesIni = mesIni;
	}

	/**
	 * @return the estat
	 */
	public EstatDTO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatDTO estat) {
		this.estat = estat;
	}

	/**
	 * @return the client
	 */
	public ClientDTO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientDTO client) {
		this.client = client;
	}

	/**
	 * @return the tipusPeriode
	 */
	public TipusPeriodeDTO getTipusPeriode() {
		return tipusPeriode;
	}

	/**
	 * @param tipusPeriode the tipusPeriode to set
	 */
	public void setTipusPeriode(TipusPeriodeDTO tipusPeriode) {
		this.tipusPeriode = tipusPeriode;
	}

	/**
	 * @return the factura
	 */
	public FacturaDTO getFactura() {
		return factura;
	}

	/**
	 * @param factura the factura to set
	 */
	public void setFactura(FacturaDTO factura) {
		this.factura = factura;
	}

	/**
	 * @return the ordre
	 */
	public String getOrdre() {
		return ordre;
	}

	/**
	 * @param ordre the ordre to set
	 */
	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}

	/**
	 * @return the dataIni
	 */
	public Date getDataIni() {
		return dataIni;
	}

	/**
	 * @param dataIni the dataIni to set
	 */
	public void setDataIni(Date dataIni) {
		this.dataIni = dataIni;
	}

	/**
	 * @return the dataFin
	 */
	public Date getDataFin() {
		return dataFin;
	}

	/**
	 * @param dataFin the dataFin to set
	 */
	public void setDataFin(Date dataFin) {
		this.dataFin = dataFin;
	}

	
	/**
	 * @return the dataIniS
	 */
	public String getDataIniS() {
		return dataIniS;
	}

	/**
	 * @param dataIniS the dataIniS to set
	 */
	public void setDataIniS(String dataIniS) {
		this.dataIniS = dataIniS;
	}

	/**
	 * @return the dataFinS
	 */
	public String getDataFinS() {
		return dataFinS;
	}

	/**
	 * @param dataFinS the dataFinS to set
	 */
	public void setDataFinS(String dataFinS) {
		this.dataFinS = dataFinS;
	}
	
	/**
	 * @return the baseImponible
	 */
	public Double getBaseImponible() {
		return baseImponible;
	}

	/**
	 * @param baseImponible the baseImponible to set
	 */
	public void setBaseImponible(Double baseImponible) {
		this.baseImponible = baseImponible;
	}

	
	/**
	 * @return the baseImponibleS
	 */
	public String getBaseImponibleS() {
		return baseImponibleS;
	}

	/**
	 * @param baseImponibleS the baseImponibleS to set
	 */
	public void setBaseImponibleS(String baseImponibleS) {
		this.baseImponibleS = baseImponibleS;
	}

	/**
	 * Genera una estructura xml a partir del contenido de un contrato, para la generacin posterior Fop.
	 * @param xslPath
	 * @return String xml
	 */
	public String getXmlFop(String xslPath){
		//para que no haya problemas en el flujo controlar que este metodo solo podr ejecutarse sobre instancias reales recuperadas de base de datos
		
		String rao		= this.getClient().getNom();
		String cif 		= this.getClient().getNif();
		String poblacio = Format.checkNull(this.getClient().getMunicipi());
		String direccio = Format.checkNull(this.getClient().getCarrer()) + " " + Format.checkNull(this.getClient().getNumero()) + " " + Format.checkNull(this.getClient().getResta());
		String cp 		= Format.checkNull(this.getClient().getCp());
		
		String id 		= this.getNumContracte();
		String data 	= Format.DATE_FORMAT.format(this.getData());
		
		//Los tipos de periodo se llaman igual en ambas lenguas...
		String periode1 = this.getTipusPeriode().getDescCa().toUpperCase();
		String periode2 = this.getTipusPeriode().getDescCa();
		
		Double importe 	= this.getBaseImponible();
		String importeS	= Format.IMPORTS_FORMAT.format(importe);
		
		//No merece la pena incorporar ninguna herramineto de trato de xml tipo xmlDOM para tan pocos xml y simples...
		StringBuffer xml = new StringBuffer("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		xml.append("<cabecera>");
		xml.append("<path valor=\"").append(xslPath).append("\"/>");
		
		xml.append("<empresa rao=\"").append(rao).append("\" cif=\"").append(cif)
										.append("\" poblacio=\"").append(poblacio)
										.append("\" direccio=\"").append(direccio)
										.append("\" cp=\"").append(cp).append("\"/>");
		
		xml.append("<contracte numero=\"").append(id).append("\" data=\"").append(data)
											.append("\" import=\"").append(importeS)
											.append("\" periode1=\"").append(periode1)
											.append("\" periode2=\"").append(periode2).append("\"/>");
		xml.append("</cabecera>");
		
		return xml.toString();
	}

	
	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((baseImponible == null) ? 0 : baseImponible.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		result = prime * result + ((dataFin == null) ? 0 : dataFin.hashCode());
		result = prime * result
				+ ((dataFinS == null) ? 0 : dataFinS.hashCode());
		result = prime * result + ((dataIni == null) ? 0 : dataIni.hashCode());
		result = prime * result
				+ ((dataIniS == null) ? 0 : dataIniS.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + ((factura == null) ? 0 : factura.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((mesIni == null) ? 0 : mesIni.hashCode());
		result = prime * result
				+ ((numContracte == null) ? 0 : numContracte.hashCode());
		result = prime * result + ((ordre == null) ? 0 : ordre.hashCode());
		result = prime * result
				+ ((tipusPeriode == null) ? 0 : tipusPeriode.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		ContracteDTO other = (ContracteDTO) obj;
		if (baseImponible == null) {
			if (other.baseImponible != null)
				return false;
		} else if (!baseImponible.equals(other.baseImponible))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		if (dataFin == null) {
			if (other.dataFin != null)
				return false;
		} else if (!dataFin.equals(other.dataFin))
			return false;
		if (dataFinS == null) {
			if (other.dataFinS != null)
				return false;
		} else if (!dataFinS.equals(other.dataFinS))
			return false;
		if (dataIni == null) {
			if (other.dataIni != null)
				return false;
		} else if (!dataIni.equals(other.dataIni))
			return false;
		if (dataIniS == null) {
			if (other.dataIniS != null)
				return false;
		} else if (!dataIniS.equals(other.dataIniS))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (factura == null) {
			if (other.factura != null)
				return false;
		} else if (!factura.equals(other.factura))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (mesIni == null) {
			if (other.mesIni != null)
				return false;
		} else if (!mesIni.equals(other.mesIni))
			return false;
		if (numContracte == null) {
			if (other.numContracte != null)
				return false;
		} else if (!numContracte.equals(other.numContracte))
			return false;
		if (ordre == null) {
			if (other.ordre != null)
				return false;
		} else if (!ordre.equals(other.ordre))
			return false;
		if (tipusPeriode == null) {
			if (other.tipusPeriode != null)
				return false;
		} else if (!tipusPeriode.equals(other.tipusPeriode))
			return false;
		return true;
	}
	
}
