package com.ferri.service.dto;

import java.util.Date;

import com.ferri.core.vo.commons.BaseDTO;
import com.ferri.persistence.bean.impl.TipusClientVO;
import com.ferri.portlet.utils.Format;

/**
 * Implementaci de la instancia DTO. Taula: tfc_factura
 * @author dferri
 *
 */
public class FacturaDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	
	//PK
	private String numFactura = null;
	
	//Fields
	private Date data = null;
	private Double baseImponible = null;
	private String concepte = null;
	private Date dataCobrament = null;
	private EstatDTO estat = null;
	private ClientDTO client = null;
	
	//Extra Cerca
	private String ordre = null;
	private Date dataIni = null;
	private Date dataFin = null;
	private Double baseIni = null;
	private Double baseFin = null;
	
	private String dataIniS = null;
	private String dataFinS = null;
	private String baseIniS = null;
	private String baseFinS = null;
	
	//Extra Form
	private String baseImponibleS = null;

	/**
	 * Creador instancia
	 * @param numFactura
	 * @param data
	 * @param baseImponible
	 * @param concepte
	 * @param dataCobrament
	 * @param estat
	 * @param client
	 */
	public FacturaDTO(String numFactura, Date data, Double baseImponible, String concepte, Date dataCobrament, EstatDTO estat, ClientDTO client) {		
		this.setNumFactura(numFactura);
		this.setData(data);		
		this.setBaseImponible(baseImponible);
		this.setConcepte(concepte);
		this.setDataCobrament(dataCobrament);
		this.setEstat(estat);
		this.setClient(client);
	}

	/**
	 * Creador instancia
	 * @param data
	 * @param baseImponible
	 * @param concepte
	 * @param dataCobrament
	 * @param estat
	 * @param client
	 */
	public FacturaDTO(Date data, Double baseImponible, String concepte, Date dataCobrament, EstatDTO estat, ClientDTO client) {		
		this.setData(data);		
		this.setBaseImponible(baseImponible);
		this.setConcepte(concepte);
		this.setDataCobrament(dataCobrament);
		this.setEstat(estat);
		this.setClient(client);
	}
	
	/**
	 * Creador instancia
	 */
	public FacturaDTO(){}

	/**
	 * @return the numFactura
	 */
	public String getNumFactura() {
		return numFactura;
	}

	/**
	 * @param numFactura the numFactura to set
	 */
	public void setNumFactura(String numFactura) {
		this.numFactura = numFactura;
	}

	/**
	 * @return the data
	 */
	public Date getData() {
		return data;
	}

	/**
	 * @param data the data to set
	 */
	public void setData(Date data) {
		this.data = data;
	}

	/**
	 * @return the baseImponible
	 */
	public Double getBaseImponible() {
		return baseImponible;
	}

	/**
	 * @param baseImponible the baseImponible to set
	 */
	public void setBaseImponible(Double baseImponible) {
		this.baseImponible = baseImponible;
	}

	/**
	 * @return the concepte
	 */
	public String getConcepte() {
		return concepte;
	}

	/**
	 * @param concepte the concepte to set
	 */
	public void setConcepte(String concepte) {
		this.concepte = concepte;
	}

	/**
	 * @return the dataCobrament
	 */
	public Date getDataCobrament() {
		return dataCobrament;
	}

	/**
	 * @param dataCobrament the dataCobrament to set
	 */
	public void setDataCobrament(Date dataCobrament) {
		this.dataCobrament = dataCobrament;
	}

	/**
	 * @return the serialversionuid
	 */
	public static long getSerialversionuid() {
		return serialVersionUID;
	}

	/**
	 * @return the estat
	 */
	public EstatDTO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatDTO estat) {
		this.estat = estat;
	}

	/**
	 * @return the client
	 */
	public ClientDTO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientDTO client) {
		this.client = client;
	}

	
	/**
	 * @return the ordre
	 */
	public String getOrdre() {
		return ordre;
	}

	/**
	 * @param ordre the ordre to set
	 */
	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}
	

	/**
	 * @return the dataIni
	 */
	public Date getDataIni() {
		return dataIni;
	}

	/**
	 * @param dataIni the dataIni to set
	 */
	public void setDataIni(Date dataIni) {
		this.dataIni = dataIni;
	}

	/**
	 * @return the dataFin
	 */
	public Date getDataFin() {
		return dataFin;
	}

	/**
	 * @param dataFin the dataFin to set
	 */
	public void setDataFin(Date dataFin) {
		this.dataFin = dataFin;
	}

	/**
	 * @return the baseIni
	 */
	public Double getBaseIni() {
		return baseIni;
	}

	/**
	 * @param baseIni the baseIni to set
	 */
	public void setBaseIni(Double baseIni) {
		this.baseIni = baseIni;
	}

	/**
	 * @return the baseFin
	 */
	public Double getBaseFin() {
		return baseFin;
	}

	/**
	 * @param baseFin the baseFin to set
	 */
	public void setBaseFin(Double baseFin) {
		this.baseFin = baseFin;
	}

	/**
	 * @return the baseImponibleS
	 */
	public String getBaseImponibleS() {
		return baseImponibleS;
	}

	/**
	 * @param baseImponibleS the baseImponibleS to set
	 */
	public void setBaseImponibleS(String baseImponibleS) {
		this.baseImponibleS = baseImponibleS;
	}

	/**
	 * @return the dataIniS
	 */
	public String getDataIniS() {
		return dataIniS;
	}

	/**
	 * @param dataIniS the dataIniS to set
	 */
	public void setDataIniS(String dataIniS) {
		this.dataIniS = dataIniS;
	}

	/**
	 * @return the dataFinS
	 */
	public String getDataFinS() {
		return dataFinS;
	}

	/**
	 * @param dataFinS the dataFinS to set
	 */
	public void setDataFinS(String dataFinS) {
		this.dataFinS = dataFinS;
	}

	/**
	 * @return the baseIniS
	 */
	public String getBaseIniS() {
		return baseIniS;
	}

	/**
	 * @param baseIniS the baseIniS to set
	 */
	public void setBaseIniS(String baseIniS) {
		this.baseIniS = baseIniS;
	}

	/**
	 * @return the baseFinS
	 */
	public String getBaseFinS() {
		return baseFinS;
	}

	/**
	 * @param baseFinS the baseFinS to set
	 */
	public void setBaseFinS(String baseFinS) {
		this.baseFinS = baseFinS;
	}
	
	/**
	 * Calcla el valor IRPF a partir con el atributo baseImponible y un parametro de entrada de porcentaje de este impuesto.
	 * @param percentIRP
	 * @return valor absuluto resultante
	 */
	public Double getIRPF(Double percentIRP){
		if(baseImponible != null){			
			return (baseImponible/100)*percentIRP;			
		}
		else return 0.0;
	}
	
	/**
	 * Calcla el valor IVA a partir con el atributo baseImponible y un parametro de entrada de porcentaje de este impuesto.
	 * @param percentIVA
	 * @return valor absuluto resultante	 
	 */
	public Double getIVA(Double percentIVA){
		if(baseImponible != null){			
			return (baseImponible/100)*percentIVA;			
		}
		else return 0.0;
	}
	
	/**
	 * Genera una estructura xml a partir del contenido de una factura, para la generacin posterior Fop.
	 * @param xslPath
	 * @param percentIVA
	 * @param percentIRPF
	 * @return string xml
	 */
	public String getXmlFop(String xslPath, Double percentIVA, Double percentIRPF){
		//para que no haya problemas en el flujo controlar que este metodo solo podr ejecutarse sobre instancias reales recuperadas de base de datos
		
		String rao		= this.getClient().getNom();
		String cif 		= this.getClient().getNif();
		String poblacio = Format.checkNull(this.getClient().getMunicipi());
		String direccio = Format.checkNull(this.getClient().getCarrer()) + " " + Format.checkNull(this.getClient().getNumero()) + " " + Format.checkNull(this.getClient().getResta());
		String cp 		= Format.checkNull(this.getClient().getCp());
		
		String id 		= this.getNumFactura();
		String data 	= Format.DATE_FORMAT.format(this.getData());
		Double importe 	= this.getBaseImponible();
		String importeS	= Format.IMPORTS_FORMAT.format(importe);
		Double iva 		= this.getIVA(percentIVA);
		String ivaS		= Format.IMPORTS_FORMAT.format(iva);
		Double irpf 	= this.getClient().getTipusClient().getId().intValue() == TipusClientVO.EMPRESA.intValue() ? this.getIRPF(percentIRPF) : 0.0;
		String irpfS 	= Format.IMPORTS_FORMAT.format(irpf);
		Double total 	= importe + iva - irpf;
		String totalS 	= Format.IMPORTS_FORMAT.format(total);
		
		String preConcepte = this.getConcepte().replaceAll("\r", "\n").replaceAll("\n", "@@@");
		String liniasConcepte[] = preConcepte.split("@@@");
		
		//No merece la pena incorporar ninguna herramineto de trato de xml tipo xmlDOM para tan pocos xml y simples...
		StringBuffer xml = new StringBuffer("<?xml version=\"1.0\" encoding=\"UTF-8\"?>");
		xml.append("<cabecera>");
		xml.append("<path valor=\"").append(xslPath).append("\"/>");
		
		for (String concepte : liniasConcepte) {
			xml.append("<linia texte=\"").append(concepte).append("\"/>");
		}
		
		xml.append("<empresa rao=\"").append(rao).append("\" cif=\"").append(cif)
									.append("\" poblacio=\"").append(poblacio)
									.append("\" direccio=\"").append(direccio)
									.append("\" cp=\"").append(cp).append("\"/>");
		
		xml.append("<facturacio numero=\"").append(id).append("\" data=\"").append(data)
											.append("\" import=\"").append(importeS)
											.append("\" iva=\"").append(ivaS)
											.append("\" irpf=\"").append(irpfS)
											.append("\" total=\"").append(totalS).append("\"/>");
		
		xml.append("</cabecera>");
		
		return xml.toString();
	}
	
	
	
	
	
	

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result
				+ ((baseImponible == null) ? 0 : baseImponible.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result
				+ ((concepte == null) ? 0 : concepte.hashCode());
		result = prime * result + ((data == null) ? 0 : data.hashCode());
		result = prime * result
				+ ((dataCobrament == null) ? 0 : dataCobrament.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + hashCode;
		result = prime * result
				+ ((numFactura == null) ? 0 : numFactura.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		FacturaDTO other = (FacturaDTO) obj;
		if (baseImponible == null) {
			if (other.baseImponible != null)
				return false;
		} else if (!baseImponible.equals(other.baseImponible))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (concepte == null) {
			if (other.concepte != null)
				return false;
		} else if (!concepte.equals(other.concepte))
			return false;
		if (data == null) {
			if (other.data != null)
				return false;
		} else if (!data.equals(other.data))
			return false;
		if (dataCobrament == null) {
			if (other.dataCobrament != null)
				return false;
		} else if (!dataCobrament.equals(other.dataCobrament))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (numFactura == null) {
			if (other.numFactura != null)
				return false;
		} else if (!numFactura.equals(other.numFactura))
			return false;
		return true;
	}

}
