package com.ferri.service.dto;

import com.ferri.core.vo.commons.BaseDTO;

import java.util.Date;

/**
 * Implementaci de la instancia DTO. Taula: tfc_intervencio
 * @author dferri
 *
 */
public class IntervencioDTO extends BaseDTO
{
	private static final long serialVersionUID = -6593817005500122076L;
	private int hashCode = -2147483648;

	
	//PK
	private Long id = null;
	
	//Fields
	private Integer		mes 			= null;
	private Integer		any 			= null;
	private Date		dataIntervencio	= null;	
	private ContracteDTO contracte 		= null;
	private ClientDTO 	client  		= null;
	private EstatDTO 	estat 			= null;
	
	//Extra
	private String ordre = null;
	private Date mesAnyIni = null;
	private Date mesAnyFin = null;
	
	private String dataIniS = null;
	private String dataFinS = null;

	/**
	 * Creador instancia
	 * @param id
	 * @param mes
	 * @param any
	 * @param dataIntervencio
	 * @param contracte
	 * @param client
	 * @param estat
	 */
	public IntervencioDTO(Long id, Integer mes, Integer	any, Date dataIntervencio, ContracteDTO contracte, ClientDTO client, EstatDTO estat) {		
		setId(id);
		setMes(mes);
		setAny(any);
		setDataIntervencio(dataIntervencio);
		setContracte(contracte);
		setClient(client);
		setEstat(estat);
	}

	/**
	 * Creador instancia
	 * @param mes
	 * @param any
	 * @param dataIntervencio
	 * @param contracte
	 * @param client
	 * @param estat
	 */
	public IntervencioDTO(Integer mes, Integer any, Date dataIntervencio, ContracteDTO contracte, ClientDTO client, EstatDTO estat) {		
		setMes(mes);
		setAny(any);
		setDataIntervencio(dataIntervencio);
		setContracte(contracte);
		setClient(client);
		setEstat(estat);
	}
	
	/**
	 * Creador instancia
	 */
	public IntervencioDTO(){}

	/**
	 * @return the id
	 */
	public Long getId() {
		return id;
	}

	/**
	 * @param id the id to set
	 */
	public void setId(Long id) {
		this.id = id;
	}

	/**
	 * @return the mes
	 */
	public Integer getMes() {
		return mes;
	}

	/**
	 * @param mes the mes to set
	 */
	public void setMes(Integer mes) {
		this.mes = mes;
	}

	/**
	 * @return the dataIntervencio
	 */
	public Date getDataIntervencio() {
		return dataIntervencio;
	}

	/**
	 * @param dataIntervencio the dataIntervencio to set
	 */
	public void setDataIntervencio(Date dataIntervencio) {
		this.dataIntervencio = dataIntervencio;
	}

	/**
	 * @return the contracte
	 */
	public ContracteDTO getContracte() {
		return contracte;
	}

	/**
	 * @param contracte the contracte to set
	 */
	public void setContracte(ContracteDTO contracte) {
		this.contracte = contracte;
	}

	/**
	 * @return the client
	 */
	public ClientDTO getClient() {
		return client;
	}

	/**
	 * @param client the client to set
	 */
	public void setClient(ClientDTO client) {
		this.client = client;
	}

	/**
	 * @return the estat
	 */
	public EstatDTO getEstat() {
		return estat;
	}

	/**
	 * @param estat the estat to set
	 */
	public void setEstat(EstatDTO estat) {
		this.estat = estat;
	}
	
	/**
	 * @return the ordre
	 */
	public String getOrdre() {
		return ordre;
	}

	
	/**
	 * @return the any
	 */
	public Integer getAny() {
		return any;
	}

	/**
	 * @param any the any to set
	 */
	public void setAny(Integer any) {
		this.any = any;
	}

	/**
	 * @param ordre the ordre to set
	 */
	public void setOrdre(String ordre) {
		this.ordre = ordre;
	}

	/**
	 * @return the mesAnyIni
	 */
	public Date getMesAnyIni() {
		return mesAnyIni;
	}

	/**
	 * @param mesAnyIni the mesAnyIni to set
	 */
	public void setMesAnyIni(Date mesAnyIni) {
		this.mesAnyIni = mesAnyIni;
	}

	/**
	 * @return the mesAnyFin
	 */
	public Date getMesAnyFin() {
		return mesAnyFin;
	}

	/**
	 * @param mesAnyFin the mesAnyFin to set
	 */
	public void setMesAnyFin(Date mesAnyFin) {
		this.mesAnyFin = mesAnyFin;
	}
	
	/**
	 * @return the dataIniS
	 */
	public String getDataIniS() {
		return dataIniS;
	}

	/**
	 * @param dataIniS the dataIniS to set
	 */
	public void setDataIniS(String dataIniS) {
		this.dataIniS = dataIniS;
	}

	/**
	 * @return the dataFinS
	 */
	public String getDataFinS() {
		return dataFinS;
	}

	/**
	 * @param dataFinS the dataFinS to set
	 */
	public void setDataFinS(String dataFinS) {
		this.dataFinS = dataFinS;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#hashCode()
	 */
	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((any == null) ? 0 : any.hashCode());
		result = prime * result + ((client == null) ? 0 : client.hashCode());
		result = prime * result
				+ ((contracte == null) ? 0 : contracte.hashCode());
		result = prime * result
				+ ((dataIntervencio == null) ? 0 : dataIntervencio.hashCode());
		result = prime * result + ((estat == null) ? 0 : estat.hashCode());
		result = prime * result + hashCode;
		result = prime * result + ((id == null) ? 0 : id.hashCode());
		result = prime * result + ((mes == null) ? 0 : mes.hashCode());
		return result;
	}

	/* (non-Javadoc)
	 * @see java.lang.Object#equals(java.lang.Object)
	 */
	@Override
	public boolean equals(Object obj) {
		if (this == obj)
			return true;
		if (obj == null)
			return false;
		if (getClass() != obj.getClass())
			return false;
		IntervencioDTO other = (IntervencioDTO) obj;
		if (any == null) {
			if (other.any != null)
				return false;
		} else if (!any.equals(other.any))
			return false;
		if (client == null) {
			if (other.client != null)
				return false;
		} else if (!client.equals(other.client))
			return false;
		if (contracte == null) {
			if (other.contracte != null)
				return false;
		} else if (!contracte.equals(other.contracte))
			return false;
		if (dataIntervencio == null) {
			if (other.dataIntervencio != null)
				return false;
		} else if (!dataIntervencio.equals(other.dataIntervencio))
			return false;
		if (estat == null) {
			if (other.estat != null)
				return false;
		} else if (!estat.equals(other.estat))
			return false;
		if (hashCode != other.hashCode)
			return false;
		if (id == null) {
			if (other.id != null)
				return false;
		} else if (!id.equals(other.id))
			return false;
		if (mes == null) {
			if (other.mes != null)
				return false;
		} else if (!mes.equals(other.mes))
			return false;
		return true;
	}
}
