package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.AdministradorVO;
import com.ferri.persistence.bean.impl.GestoriaVO;
import com.ferri.service.dto.AdministradorDTO;
import com.ferri.service.dto.GestoriaDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Administrador.
 * @author dferri
 *
 */
public class AdministradorConverter extends AbstractConverter<AdministradorDTO, AdministradorVO>
{
	public  AdministradorVO convertDTO2VO( AdministradorDTO dto) 	{

		AdministradorVO vo = new  AdministradorVO();

		vo.setNif(dto.getNif());
		vo.setNom(dto.getNom());	
		vo.setTelefon(dto.getTelefon());
		vo.setMail(dto.getMail());	
		vo.setDataAlta(dto.getDataAlta());
		vo.setDataModif(dto.getDataModif());	
		vo.setGestoria((GestoriaVO) getBeansConverter().convert(dto.getGestoria()));

		return vo;
	}

	public  AdministradorDTO convertVO2DTO( AdministradorVO vo)
	{
		AdministradorDTO dto = new  AdministradorDTO();

		dto.setNif(vo.getNif());
		dto.setNom(vo.getNom());	
		dto.setTelefon(vo.getTelefon());
		dto.setMail(vo.getMail());	
		dto.setDataAlta(vo.getDataAlta());
		dto.setDataModif(vo.getDataModif());	
		dto.setGestoria((GestoriaDTO) getBeansConverter().convert(vo.getGestoria()));

		return dto;
	}
}
