package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.AdministradorVO;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.GestoriaVO;
import com.ferri.persistence.bean.impl.TipusClientVO;
import com.ferri.service.dto.AdministradorDTO;
import com.ferri.service.dto.ClientDTO;
import com.ferri.service.dto.GestoriaDTO;
import com.ferri.service.dto.TipusClientDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Client.
 * @author dferri
 *
 */
public class ClientConverter extends AbstractConverter<ClientDTO, ClientVO>
{
	
	public  ClientVO convertDTO2VO( ClientDTO dto) 	{

		ClientVO vo = new  ClientVO();

		vo.setNif(dto.getNif());
		vo.setNom(dto.getNom());
		vo.setCarrer(dto.getCarrer());
		vo.setNumero(dto.getNumero());
		vo.setResta(dto.getResta());
		vo.setMunicipi(dto.getMunicipi());
		vo.setCp(dto.getCp());
		vo.setTelefon(dto.getTelefon());
		vo.setMail(dto.getMail());	
		vo.setDataAlta(dto.getDataAlta());
		vo.setDataModif(dto.getDataModif());	
		vo.setAdministrador((AdministradorVO) getBeansConverter().convert(dto.getAdministrador()));
		vo.setGestoria((GestoriaVO) getBeansConverter().convert(dto.getGestoria()));
		vo.setTipusClient((TipusClientVO) getBeansConverter().convert(dto.getTipusClient()));

		return vo;
	}

	public  ClientDTO convertVO2DTO( ClientVO vo)
	{
		ClientDTO dto = new  ClientDTO();

		dto.setNif(vo.getNif());
		dto.setNom(vo.getNom());
		dto.setCarrer(vo.getCarrer());
		dto.setNumero(vo.getNumero());
		dto.setResta(vo.getResta());
		dto.setMunicipi(vo.getMunicipi());
		dto.setCp(vo.getCp());
		dto.setTelefon(vo.getTelefon());
		dto.setMail(vo.getMail());	
		dto.setDataAlta(vo.getDataAlta());
		dto.setDataModif(vo.getDataModif());	
		dto.setAdministrador((AdministradorDTO) getBeansConverter().convert(vo.getAdministrador()));
		dto.setGestoria((GestoriaDTO) getBeansConverter().convert(vo.getGestoria()));
		dto.setTipusClient((TipusClientDTO) getBeansConverter().convert(vo.getTipusClient()));

		return dto;
	}
}
