package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.FacturaVO;
import com.ferri.persistence.bean.impl.ContracteVO;
import com.ferri.persistence.bean.impl.TipusPeriodeVO;
import com.ferri.service.dto.ClientDTO;
import com.ferri.service.dto.EstatDTO;
import com.ferri.service.dto.FacturaDTO;
import com.ferri.service.dto.ContracteDTO;
import com.ferri.service.dto.TipusPeriodeDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Contracte.
 * @author dferri
 *
 */
public class ContracteConverter extends AbstractConverter<ContracteDTO, ContracteVO>
{
	public  ContracteVO convertDTO2VO( ContracteDTO dto) 	{

		ContracteVO vo = new  ContracteVO();

		vo.setNumContracte(dto.getNumContracte());
		vo.setData(dto.getData());		
		vo.setMesIni(dto.getMesIni());
		vo.setBaseImponible(dto.getBaseImponible());
		vo.setEstat((EstatVO) getBeansConverter().convert(dto.getEstat()));
		vo.setClient((ClientVO) getBeansConverter().convert(dto.getClient()));		
		vo.setTipusPeriode((TipusPeriodeVO) getBeansConverter().convert(dto.getTipusPeriode()));
		vo.setFactura((FacturaVO) getBeansConverter().convert(dto.getFactura()));
		
		return vo;
	}

	public  ContracteDTO convertVO2DTO( ContracteVO vo)
	{
		ContracteDTO dto = new  ContracteDTO();

		dto.setNumContracte(vo.getNumContracte());
		dto.setData(vo.getData());		
		dto.setMesIni(vo.getMesIni());		
		dto.setBaseImponible(vo.getBaseImponible());
		dto.setEstat((EstatDTO) getBeansConverter().convert(vo.getEstat()));
		dto.setClient((ClientDTO) getBeansConverter().convert(vo.getClient()));
		dto.setTipusPeriode((TipusPeriodeDTO) getBeansConverter().convert(vo.getTipusPeriode()));		
		dto.setFactura((FacturaDTO) getBeansConverter().convert(vo.getFactura()));

		return dto;
	}
}
