package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.FacturaVO;
import com.ferri.service.dto.ClientDTO;
import com.ferri.service.dto.EstatDTO;
import com.ferri.service.dto.FacturaDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Factura.
 * @author dferri
 *
 */
public class FacturaConverter extends AbstractConverter<FacturaDTO, FacturaVO>
{
	public  FacturaVO convertDTO2VO( FacturaDTO dto) 	{

		FacturaVO vo = new  FacturaVO();

		vo.setNumFactura(dto.getNumFactura());
		vo.setData(dto.getData());		
		vo.setBaseImponible(dto.getBaseImponible());
		vo.setConcepte(dto.getConcepte());
		vo.setDataCobrament(dto.getDataCobrament());		
		vo.setEstat((EstatVO) getBeansConverter().convert(dto.getEstat()));
		vo.setClient((ClientVO) getBeansConverter().convert(dto.getClient()));

		return vo;
	}

	public  FacturaDTO convertVO2DTO( FacturaVO vo)
	{
		FacturaDTO dto = new  FacturaDTO();

		dto.setNumFactura(vo.getNumFactura());
		dto.setData(vo.getData());		
		dto.setBaseImponible(vo.getBaseImponible());
		dto.setConcepte(vo.getConcepte());
		dto.setDataCobrament(vo.getDataCobrament());		
		dto.setEstat((EstatDTO) getBeansConverter().convert(vo.getEstat()));
		dto.setClient((ClientDTO) getBeansConverter().convert(vo.getClient()));

		return dto;
	}
}
