package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.ContracteVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.IntervencioVO;
import com.ferri.service.dto.ClientDTO;
import com.ferri.service.dto.ContracteDTO;
import com.ferri.service.dto.EstatDTO;
import com.ferri.service.dto.IntervencioDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Intervencio.
 * @author dferri
 *
 */
public class IntervencioConverter extends AbstractConverter<IntervencioDTO, IntervencioVO>
{
	public  IntervencioVO convertDTO2VO( IntervencioDTO dto) 	{

		IntervencioVO vo = new  IntervencioVO();

		vo.setId(dto.getId());
		vo.setMes(dto.getMes());
		vo.setAny(dto.getAny());
		vo.setDataIntervencio(dto.getDataIntervencio());
		vo.setContracte((ContracteVO) getBeansConverter().convert(dto.getContracte()));		
		vo.setClient((ClientVO) getBeansConverter().convert(dto.getClient()));
		vo.setEstat((EstatVO) getBeansConverter().convert(dto.getEstat()));		

		return vo;
	}

	public  IntervencioDTO convertVO2DTO( IntervencioVO vo)
	{
		IntervencioDTO dto = new  IntervencioDTO();

		dto.setId(vo.getId());
		dto.setMes(vo.getMes());
		dto.setAny(vo.getAny());
		dto.setDataIntervencio(vo.getDataIntervencio());
		dto.setContracte((ContracteDTO) getBeansConverter().convert(vo.getContracte()));		
		dto.setClient((ClientDTO) getBeansConverter().convert(vo.getClient()));
		dto.setEstat((EstatDTO) getBeansConverter().convert(vo.getEstat()));

		return dto;
	}
}
