package com.ferri.service.dto.converters;

import com.ferri.core.vo.commons.converters.AbstractConverter;
import com.ferri.persistence.bean.impl.ClientVO;
import com.ferri.persistence.bean.impl.EstatVO;
import com.ferri.persistence.bean.impl.FacturaVO;
import com.ferri.persistence.bean.impl.PressupostVO;
import com.ferri.service.dto.ClientDTO;
import com.ferri.service.dto.EstatDTO;
import com.ferri.service.dto.FacturaDTO;
import com.ferri.service.dto.PressupostDTO;

/**
 * Convertidor de DTO a VO i al revs per l'entitat Pressupost.
 * @author dferri
 *
 */
public class PressupostConverter extends AbstractConverter<PressupostDTO, PressupostVO>
{
	public  PressupostVO convertDTO2VO( PressupostDTO dto) 	{

		PressupostVO vo = new  PressupostVO();

		vo.setNumPressupost(dto.getNumPressupost());
		vo.setData(dto.getData());		
		vo.setBaseImponible(dto.getBaseImponible());
		vo.setConcepte(dto.getConcepte());
		vo.setMotiuCancel(dto.getMotiuCancel());
		vo.setDataModif(dto.getDataModif());
		vo.setEstat((EstatVO) getBeansConverter().convert(dto.getEstat()));
		vo.setClient((ClientVO) getBeansConverter().convert(dto.getClient()));
		vo.setFactura((FacturaVO) getBeansConverter().convert(dto.getFactura()));
		
		return vo;
	}

	public  PressupostDTO convertVO2DTO( PressupostVO vo)
	{
		PressupostDTO dto = new  PressupostDTO();

		dto.setNumPressupost(vo.getNumPressupost());
		dto.setData(vo.getData());		
		dto.setBaseImponible(vo.getBaseImponible());
		dto.setConcepte(vo.getConcepte());
		dto.setMotiuCancel(vo.getMotiuCancel());
		dto.setDataModif(vo.getDataModif());
		dto.setEstat((EstatDTO) getBeansConverter().convert(vo.getEstat()));
		dto.setClient((ClientDTO) getBeansConverter().convert(vo.getClient()));
		dto.setFactura((FacturaDTO) getBeansConverter().convert(vo.getFactura()));

		return dto;
	}
}
