package com.ferri.service.dto.utils;

import java.io.Serializable;

/**
 * Classe Contenedora de l'ordenci
 * @author dferri
 *
 */
public class Order implements Serializable {
	
	private static final long serialVersionUID = -5124589682599117945L;
	private Boolean ascending = null;

	private String propertyName = null;

	/**
	 * Creador Instancia
	 * @param propertyName
	 * @param ascending
	 */
	public Order(String propertyName, Boolean ascending)
	{
		this.propertyName = propertyName;
		this.ascending = ascending;
	}


	/**
	 * @return the ascending
	 */
	public Boolean getAscending() {
		return ascending;
	}


	/**
	 * @param ascending the ascending to set
	 */
	public void setAscending(Boolean ascending) {
		this.ascending = ascending;
	}



	/**
	 * @return the propertyName
	 */
	public String getPropertyName() {
		return propertyName;
	}



	/**
	 * @param propertyName the propertyName to set
	 */
	public void setPropertyName(String propertyName) {
		this.propertyName = propertyName;
	}


	/**
	 * Comprova que els camps no son nulls
	 * @return
	 */
	public boolean isFilled()
	{
		return (getPropertyName() != null) && (getAscending() != null);
	}

	public String toString()
	{
		return isFilled() ? getPropertyName() + " " + ((getAscending() != null) && (getAscending().booleanValue()) ? "asc" : "desc") : "is empty";
	}
}

